--[[
NAME
    range_sym
FUNCTION
    range_sym(plot, arr, dx)
NOTES
    Adds range symbols to the plot.
INPUTS
    plot   - zePlot object
    arr    - zeArray object having 4 vectors containing data of x, y, min, and max
    dx     - symbol with in plot coordinate
OUTPUTS
    a zeLine object.
]]

require("register")

function range_sym(plot, arr, size)
    local node, shape, xyz = zeGrf.new("node", "line", "vertex")
    plot:add(shape)
    shape:set{vertex = xyz, type = "lines", solid = 1.5}
    local n = arr:size()
    local dx = size / 2
    for i = 1, n do
        local x = arr:getele(i-1, 0)
        local y = arr:getele(i-1, 1)
        local y1 = arr:getele(i-1, 2)
        local y2 = arr:getele(i-1, 3)
        local z = 0
        xyz:add(x, y1, z) 
        xyz:add(x, y2, z) 
        xyz:add(x-dx, y1, z) 
        xyz:add(x+dx, y1, z) 
        xyz:add(x-dx, y2, z) 
        xyz:add(x+dx, y2, z)
    end
    return shape
end
